#!/bin/python3
import time
import os
import sys
from bs4 import BeautifulSoup
from playwright.sync_api import sync_playwright

def is_bottom_of_page(page):
    scroll_position = page.evaluate("window.scrollY")
    total_height = page.evaluate("document.body.scrollHeight")
    return scroll_position == total_height

if os.path.exists('list.txt'):
    print('list file exists')
else:
    print('creating list file')
    with open('list.txt', 'w'):
        pass

p = sync_playwright().start()
browser = p.chromium.launch(headless=False, slow_mo=50)
page = browser.new_page()
page.goto('https://twitter.com/androidfilehost')
time.sleep(8)
user_input = input("Please enter something to continue")
while not is_bottom_of_page(page):
    html = page.content()
    page.keyboard.press('PageDown')
    time.sleep(.5)
    soup = BeautifulSoup(html, 'html.parser')
    status_links = soup.find_all('a')
    status_links_string=str(status_links)
    replaced_string = status_links_string.replace('"', '\n')
    filtered_lines = [line for line in replaced_string.split('\n') if 'status' in line]
    for line in filtered_lines:
        if line.count('/') > 3:
            continue

        line_link = "https://twitter.com" + line
        print(line_link)
        last_slash_index = line.rfind('/')
        id = line[last_slash_index + 1:]
        with open('list.txt', 'r+') as file:
            file_content = file.read()
            if id in file_content:
                print(line_link + ' already in list.txt')
                continue
            else:
                print(line_link + ' not in link.txt, appending to list')
                file.write(line_link + '\n')


