#!/bin/python3
from playwright.sync_api import sync_playwright
import time
import os
import json
from lxml import etree
import requests
import subprocess
import sys
url = sys.argv[1]
url_parts = url.split('/')
directory = os.getcwd()
filenames = os.listdir(directory)

for filename in filenames:
    if url_parts[-1] in filename:
        print('tweet', url_parts[-1], 'already downloaded')
#        sys.exit()

user_agent_windows_10 = "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.198 Safari/537.36"
p = sync_playwright().start()
browser = p.firefox.launch(headless=False, slow_mo=50)
context = browser.new_context()
page = context.new_page()
page.set_viewport_size({"width": 1920, "height": 1080})
page.goto(url)
time.sleep(8)
html = page.content()
output_file = "tweet.json"
root = etree.HTML(html)

print(url)
text_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[1]/div/div[1]/span'
date_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[4]/div/div[1]/div/div[1]/a/time'
views_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[4]/div/div[1]/div/div[3]/span/div/span/span/span'
reposts_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[5]/div[2]/a/div/span/span/span'
quotes_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[5]/div[3]/a/div/span/span/span'
likes_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[5]/div[4]/a/div/span/span/span'
bookmarks_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[5]/div[5]/div/div/span/span/span'
author_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[2]/div[2]/div/div/div[1]/div/div/div[1]/div/a/div/div[1]/span/span'
#image_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[2]/div/div/div/div/div/div/div/a/div/div[2]/div/img'
video_xpath = '/html/body/div[1]/div/div/div[2]/main/div/div/div/div[1]/div/section/div/div/div[1]/div/div/article/div/div/div[3]/div[2]/div/div/div/div/div/div/div/div/div/div[2]/div/div/div/div[2]/div/div[1]/div/video'

text = root.xpath(text_xpath)
date = root.xpath(date_xpath)
views = root.xpath(views_xpath)
reposts = root.xpath(reposts_xpath)
quotes = root.xpath(quotes_xpath)
likes = root.xpath(likes_xpath)
bookmarks = root.xpath(bookmarks_xpath)
author = root.xpath(author_xpath)

article_elements = root.xpath("//article")
article_content_str = etree.tostring(article_elements[0], method="html").decode("utf-8")
if "<img" in article_content_str:
    img_tags = article_elements[0].xpath(".//img")
has_images = 'false'

text = text[0].text.strip() if text else None
date = date[0].get("datetime").strip() if date else None
date = date.replace('\u00b7', '')
views = views[0].text.strip() if views else None
reposts = reposts[0].text.strip() if reposts else None
quotes = quotes[0].text.strip() if quotes else None
likes = likes[0].text.strip() if likes else None
bookmarks = bookmarks[0].text.strip() if bookmarks else None
author = author[0].text.strip() if author else None

dir = date + "_" + url_parts[3] + "_" + url_parts[-1]
dir = dir.replace(' ', '_').replace(':', '-').replace(',', '')
os.makedirs(dir, exist_ok=True)
os.chdir(dir)

if img_tags:
    first_img = img_tags[0]
    first_img.getparent().remove(first_img)
    img_count = 0
    for img in img_tags:
        src = img.get("src")
        if src and src.startswith("https://pbs.twimg.com/media"):
            split_src = src.split('&')
            src = split_src[0]
            split_src = src.split('=')
            format = split_src[1]
            print(src, format)
            img_count += 1
            has_images = 'true'
            response = requests.get(src, headers={"User-Agent": user_agent_windows_10})
            filename = 'image' + str(img_count) + '.' + str(format)
            with open(filename, 'wb') as f:
                f.write(response.content)


print(img_tags)


video = root.xpath(video_xpath)
has_video = 'false'

if len(video) > 0:
    has_video = 'True'
    command = ['yt-dlp', '--trim-filenames', '20', url]
    output = subprocess.run(command, capture_output=True, text=True)
    print(output.stdout)
    print(output.stderr)

#if image != []:
#    has_image = 'true'
#    image_url = image.get("src")
#    print(image_url)
#    response = requests.get(image_url, headers={"User-Agent": user_agent_windows_10})
#    with open("image.jpg", 'wb') as f:
#       f.write(response.content)

data = {
    "text": text,
    "date": date,
    "views": views,
    "reposts": reposts,
    "quotes": quotes,
    "likes": likes,
    "bookmarks": bookmarks,
    "author": author,
    "author_handle": url_parts[3],
    "has_video": has_video,
    "has_images": has_images,
    "id": url_parts[-1]
}

with open(output_file, 'w') as f:
    json.dump(data, f, indent=4)
print("Extracted data saved to:", output_file)
print(data)
print(text)
os.chdir('..')
